##===< ID >===
execute as @a unless score @s ID matches -2147483648..2147483647 at @s run function gc:worlds/hub/teleport_player

execute as @a store result score @s ID run data get entity @s UUID[1]

scoreboard players set $playercount Dummy 0
execute as @a run scoreboard players add $playercount Dummy 1

##===< game >===
execute if score $game isGameActive matches 1 if score $playercount Dummy matches 1.. run function gc:game/onactive

##===< worldstate >===
execute if score $game SelectedGameMode matches 1.. run kill @e[type=item,tag=!invulnerable]
execute as @e at @s run function gc:player/pickups/mechanics


##===< lobby >===
scoreboard players remove $game isGameActive 0
execute if score $game isGameActive matches 0 run function gc:worlds/hub/manage/main
effect give @e[type=villager] invisibility 10 0 true
effect give @a[tag=in_lobby] weakness 1 255 true
execute as @a[tag=in_lobby] run attribute @s minecraft:generic.movement_speed modifier remove 0-0-0-0-1

#info items
execute as @a[gamemode=!spectator,scores={SelectedCharacter=1..},tag=in_lobby] at @s run function gc:characters/info

#tp any players not in lobby back to lobby when no game is active
execute if score $game isGameActive matches 0 as @a if score @s[tag=!in_lobby] GameID matches -2147483648..2147483647 at @s run function gc:worlds/hub/teleport_player


tag @a remove in_lobby 
execute in overworld positioned 0 100 0 run tag @a[distance=..200] add in_lobby
gamemode adventure @a[tag=in_lobby,gamemode=survival]
execute as @e[scores={ClickVillager=1..}] at @s run function gc:player/interact/villager
scoreboard players set @a[tag=in_lobby] HP 100



##===< using item >===
scoreboard players add @e[scores={UseItem=1..}] UsingItem 4
scoreboard players set @e[scores={UseItem=1..,UseDelay=1..}] UsingItem 0
scoreboard players remove @e[scores={HitDummy=1..}] HitDummy 1
scoreboard players set @e[scores={Hit=1..}] HitDummy 2

##===< ai >===
execute as @e[type=wandering_trader] at @s run data merge entity @s {HandItems:[{id:"minecraft:air",Count:1b},{}]}
execute as @e[tag=npc] at @s run function gc:npc/ai/main


##===< abilities >===
execute as @a[gamemode=!spectator,scores={SelectedCharacter=1..},tag=!in_lobby] at @s run function gc:abilities/use_abilities
execute as @e[scores={Chokingtimer=1..}] run function gc:abilities/vader/choking

##===< weapons >===
execute as @a[gamemode=!spectator,scores={SelectedCharacter=1..},tag=!in_lobby] at @s run function gc:weapons/use_weapons


##===< player thingies >===
execute as @a[gamemode=!spectator] at @s run function gc:player/charge/charge


##===< status effects >===
execute as @e[tag=!invulnerable] at @s run function gc:weapons/status/burn
execute as @e[tag=!invulnerable] at @s run function gc:weapons/status/scan
execute as @e[tag=!invulnerable] at @s run function gc:weapons/status/jamweapon
execute as @e[tag=!invulnerable] at @s run function gc:weapons/status/cooldowns


##===< health >===
execute as @a[tag=!dead] at @s run function gc:player/health_manager
execute as @a[tag=!dead,gamemode=adventure] at @s run function gc:player/outofbounds
execute as @a[scores={spawnProtectionTimer=1..}] at @s run function gc:player/spawnprotection
execute as @a[tag=dead] at @s run function gc:player/deathtimer
execute as @e[tag=player_death_animation] at @s run function gc:player/deathanimation/main

execute as @e[type=!player,type=!item] at @s run function gc:mobs/health_manager

##===< items >===
execute as @a[gamemode=!spectator] at @s run function gc:items/set_items
# execute as @e[tag=npc] at @s run function gc:items/set_items

##===< objects >===
execute as @e[tag=bubble,tag=!hasChildren] at @s[nbt={OnGround:1b}] run function gc:abilities/leia/spawn_dome
execute as @e[tag=r2d2] at @s run function gc:abilities/leia/astromech/movemech
execute as @e[tag=shield] run data merge entity @s[nbt={OnGround:1b}] {Marker:1b}
execute as @e[tag=smokewall] run function gc:abilities/nien/smokewall_summon
execute as @e[tag=smokewallinstance] run function gc:abilities/nien/smokewall_active
execute as @e[tag=sonicimploder_effects] at @s run function gc:weapons/grenades/explode/soniceffects
execute as @e[tag=gasgrenade_effects] at @s run function gc:weapons/grenades/explode/gaseffects
execute as @e[tag=incendiarydetonator_effects] at @s run function gc:weapons/grenades/explode/incendiaryeffects
execute as @e[tag=grenade] at @s run function gc:weapons/grenades/active
execute as @e[tag=rocket] at @s run function gc:weapons/grenades/rocket
execute as @e[tag=ion_torpedo] at @s run function gc:weapons/grenades/ion_torpedo
execute as @e[tag=rollingcharge] at @s run function gc:weapons/grenades/rollingcharge


execute as @e[tag=object] at @s run function gc:objects/main
execute as @a at @s run function gc:objects/main


##===< scoreboards >===
scoreboard players set @e UseItem 0
execute as @a unless score @s UseDelay matches ..0 run scoreboard players remove @s UseDelay 1
scoreboard players remove @a SelectedCharacter 0
scoreboard players set @a ClickVillager 0

scoreboard players set @e Hit 0
scoreboard players set @e Jump 0
scoreboard players set @e Sneak 0
scoreboard players set @e[scores={UsingItem=4..}] UsingItem 4
scoreboard players remove @e[scores={UsingItem=1..}] UsingItem 1